src/Entity/Peinture.php
<?php

namespace App\Entity;

use DateTime;
use App\Entity\User;
use App\Entity\Categorie;
use Doctrine\ORM\Mapping as ORM;
use App\Repository\UserRepository;
use App\Repository\PeintureRepository;
use App\Repository\CategorieRepository;
use Doctrine\Common\Collections\Collection;
use Symfony\Component\HttpFoundation\File\File;
use Doctrine\Common\Collections\ArrayCollection;
use Vich\UploaderBundle\Mapping\Annotation as Vich;

/**
 * @ORM\Entity(repositoryClass=PeintureRepository::class)
 * @Vich\Uploadable
 */
class Peinture
{
    /**
     * @ORM\Id
     * @ORM\GeneratedValue
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $nom;

    /**
     * @ORM\Column(type="decimal", precision=6, scale=2, nullable=true)
     */
    private $largeur;

    /**
     * @ORM\Column(type="decimal", precision=6, scale=2, nullable=true)
     */
    private $hauteur;

    /**
     * @ORM\Column(type="boolean")
     */
    private $en_vente;

    /**
     * @ORM\Column(type="decimal", precision=10, scale=2)
     */
    private $prix;

    /**
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $date_realisation;

    /**
     * @ORM\Column(type="datetime")
     */
    private $createdAt;

    /**
     * @ORM\Column(type="boolean")
     */
    private $portfolio;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $slug;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $file;

    /**
     * @Vich\UploadableField(mapping="peinture_images", fileNameProperty="file")
     * @var File
     */
    private $imageFile;

    /**
     * @ORM\ManyToOne(targetEntity=User::class, inversedBy="peintures")
     * @ORM\JoinColumn(nullable=false)
     */
    private $user;

    /**
     * @ORM\ManyToMany(targetEntity=Categorie::class, inversedBy="peintures")
     */
    private $categories;

    /**
     * @ORM\Column(type="string", length=255)
     */
    private $description;

    /**
     * @ORM\OneToMany(targetEntity=Commentaire::class, mappedBy="peinture", orphanRemoval=true)
     */
    private $commentaires;

    public function __construct()
    {
        $this->categories = new ArrayCollection();
        $this->commentaires = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNom(): ?string
    {
        return $this->nom;
    }

    public function setNom(string $nom): self
    {
        $this->nom = $nom;

        return $this;
    }

    public function getLargeur(): ?string
    {
        return $this->largeur;
    }

    public function setLargeur(?string $largeur): self
    {
        $this->largeur = $largeur;

        return $this;
    }

    public function getHauteur(): ?string
    {
        return $this->hauteur;
    }

    public function setHauteur(?string $hauteur): self
    {
        $this->hauteur = $hauteur;

        return $this;
    }

    public function getEnVente(): ?bool
    {
        return $this->en_vente;
    }

    public function setEnVente(bool $en_vente): self
    {
        $this->en_vente = $en_vente;

        return $this;
    }

    public function getPrix(): ?string
    {
        return $this->prix;
    }

    public function setPrix(string $prix): self
    {
        $this->prix = $prix;

        return $this;
    }

    public function getDateRealisation(): ?\DateTimeInterface
    {
        return $this->date_realisation;
    }

    public function setDateRealisation(?\DateTimeInterface $date_realisation): self
    {
        $this->date_realisation = $date_realisation;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }

    public function setCreatedAt(?\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getPortfolio(): ?bool
    {
        return $this->portfolio;
    }

    public function setPortfolio(bool $portfolio): self
    {
        $this->portfolio = $portfolio;

        return $this;
    }

    public function getSlug(): ?string
    {
        return $this->slug;
    }

    public function setSlug(string $slug): self
    {
        $this->slug = $slug;

        return $this;
    }

    public function getFile(): ?string
    {
        return $this->file;
    }

    public function setFile(string $file): self
    {
        $this->file = $file;

        return $this;
    }

    public function getUser(): ?User
    {
        return $this->user;
    }

    public function setUser(?User $user): self
    {
        $this->user = $user;

        return $this;
    }

    /**
     * @return Collection|Categorie[]
     */
    public function getCategories(): Collection
    {
        return $this->categories;
    }

    public function addCategory(Categorie $category): self
    {
        if (!$this->categories->contains($category)) {
            $this->categories[] = $category;
        }

        return $this;
    }

    public function removeCategory(Categorie $category): self
    {
        $this->categories->removeElement($category);

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(string $description): self
    {
        $this->description = $description;

        return $this;
    }

    /**
     * @return Collection|Commentaire[]
     */
    public function getCommentaires(): Collection
    {
        return $this->commentaires;
    }

    public function addCommentaire(Commentaire $commentaire): self
    {
        if (!$this->commentaires->contains($commentaire)) {
            $this->commentaires[] = $commentaire;
            $commentaire->setPeinture($this);
        }

        return $this;
    }

    public function removeCommentaire(Commentaire $commentaire): self
    {
        if ($this->commentaires->removeElement($commentaire)) {
            // set the owning side to null (unless already changed)
            if ($commentaire->getPeinture() === $this) {
                $commentaire->setPeinture(null);
            }
        }

        return $this;
    }

    /**
     * Get the value of imageFile
     *
     * @return  File
     */
    public function getImageFile()
    {
        return $this->imageFile;
    }

    /**
     * Set the value of imageFile
     *
     * @param  File  $file
     *
     * @return  self
     */
    public function setImageFile(File $file = null)
    {
        $this->imageFile = $file;

        if ($file) {
            $this->createdAt = new \DateTime('now');
        }

        return $this;
    }
}

src/Controller/PeintureController.php
<?php

namespace App\Controller;

use App\Entity\Peinture;
use App\Repository\PeintureRepository;
use Knp\Component\Pager\PaginatorInterface;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;

class PeintureController extends AbstractController
{
    /**
     * @Route("/realisations", name="realisations")
     */
    public function realisations(
        PeintureRepository $peintureRepository,
        PaginatorInterface $paginator,
        Request $request
    ): Response {
        $data = $peintureRepository->findBy([], ['id' => 'DESC']);

        $peintures = $paginator->paginate(
            $data,
            $request->query->getInt('page', 1),
            4
        );

        return $this->render('peinture/realisations.html.twig', [
            'peintures' => $peintures,
        ]);
    }

    /**
     * @Route("realisations/{slug}", name="realisations_details")
     */
    public function detailRealisation(Peinture $peinture)
    {
        return $this->render('peinture/details.html.twig', [
            'peinture' => $peinture,
        ]);
    }
}

templates/peinture/details.html.twig
{% extends 'base.html.twig' %}
{% block title %}{% endblock %}

{% block body %}
	<div class="container-fluid px-md-0">
		<div class="row justify-content-between gx-0 mx-md-0 mb-6 mb-md-2">
			<div class="col-12 col-md-3 vh-md-100 mx-auto" style="top: 0;">
				<aside class="lex-grow-1 py-8 py-md-10">
					<div>
						<h2>{{ peinture.nom }}</h2>
						{% for cat in peinture.categories %}
							<span class="badge bg-secondary">{{ cat.nom }}</span>
						{% endfor %}
					</div>
					<p class="fs-lg text-muted">
						{{ peinture.description }}
					</p>
					<u class="list-group list-group-flush">
						<li class="list-group-item">
							<h6 class="d-flex mb-0 text-uppercase">
								Date de réalisation :
								<span class="ms-auto">{{ peinture.dateRealisation|date('d/m/Y') }}</span>
							</h6>
						</li>
						<li class="list-group-item">
							<h6 class="d-flex mb-0 text-uppercase">
								Largeur :
								<span class="ms-auto">{{ peinture.largeur }}
									cm</span>
							</h6>
						</li>
						<li class="list-group-item">
							<h6 class="d-flex mb-0 text-uppercase">
								Hauteur :
								<span class="ms-auto">{{ peinture.hauteur }}
									cm</span>
							</h6>
						</li>
						{% if peinture.enVente %}
							<li class="list-group-item">
								<h6 class="d-flex mb-0 text-uppercase">
									<strong>Disponible à la vente</strong>
									<span class="ms-auto">{{ peinture.prix }}
										€</span>
								</h6>
							</li>
						{% endif %}
					</u>
				</aside>
			</div>
			<div class="col-12 col-md-8">
				<section class="pt-md-10">
					<img src="{{ vich_uploader_asset(peinture, 'imageFile') | imagine_filter('full') }}" alt="..." class="w-100 h-auto">
				</section>

			</div>
		</div>
	</div>

{% endblock %}

templates/peinture/realisations.html.twig
{% extends 'base.html.twig' %}

{% block title %}Réalisations
{% endblock %}

{% block body %}
	<!-- ARTICLES -->
	<section class="pt-7 pt-md-10">
		<div class="container">
			<div class="row">
				<div class="col-12">
					<h2 class="mb-0">Dernières réalisations</h2>
					<p class="mb-5 text muted">
						These can be split into smaller grid size
					</p>
				</div>

				{% for peinture in peintures %}
					<div class="col-12 col-md-6 d-flex">
						<div class="card mb-6 shadow-light-lg">
							<a href="{{ path('realisations_details', {'slug': peinture.slug }) }}" class="card-img-top">
								<img src="{{ vich_uploader_asset(peinture,'imageFile') | imagine_filter('miniature') }}" alt="..." class="card-img-top">
							</a>


							<a href="{{ path('realisations_details', {'slug': peinture.slug }) }}" class="card-body">
								<h3>{{ peinture.nom }}</h3>
								<p class="mb-0 text-muted">{{ peinture.description|u.truncate(150,'...', false) }}</p>
							</a>
							<a href="{{ path('realisations_details', {'slug': peinture.slug }) }}" class="card-meta mt-auto">
								<hr class="card-meta-divider">
								<p class="h6 text-uppercase text-muted mb-0 ms-auto">
									<time>Ajoutée le
										{{ peinture.createdAt | date('d/m/Y') }}</time>
								</p>
							</a>
						</div>
					</div>
				{% endfor %}
			</div>
		</div>
		<br>
		<div class="d-flex justify-content-center">
			{% do peintures.setPageRange(4) %}
			{{ knp_pagination_render(peintures,'base/pagination.html.twig') }}
		</div>
	</section>
{% endblock %}